Index: trunk/LMDZ.GENERIC/libf/aeronostd/concentrations.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/aeronostd/concentrations.F	(revision 2541)
+++ trunk/LMDZ.GENERIC/libf/aeronostd/concentrations.F	(revision 2542)
@@ -2,19 +2,10 @@
      &                          pplay,pt,pdt,pq,pdq,ptimestep)
                                              
-      use tracer_h, only: igcm_co2, igcm_co, igcm_o, igcm_o1d,
-     &                      igcm_o2, igcm_o3, igcm_h, igcm_h2,
-     &                      igcm_oh, igcm_ho2, igcm_n2, igcm_ar,
-     &                      igcm_h2o_vap, igcm_n, igcm_no, igcm_no2,
-     &                      igcm_n2d, igcm_ch4, 
-     &                      igcm_ch3, igcm_ch, igcm_3ch2, igcm_1ch2,      
-     &                      igcm_cho, igcm_ch2o, igcm_ch3o,               
-     &                      igcm_c, igcm_c2, igcm_c2h, igcm_c2h2,         
-     &                      igcm_c2h3, igcm_c2h4, igcm_c2h6, igcm_ch2co,  
-     &                      igcm_ch3co, igcm_hcaer,
-     &                      igcm_h2o2, mmol
+      use tracer_h, only: mmol, noms, aki, cpi, nesp
 
-      use conc_mod, only: mmean, Akknew, rnew, cpnew
+      use conc_mod, only: mmean, akknew, rnew, cpnew
       USE comcstfi_mod                   
       use callkeys_mod
+      use chimiedata_h
       implicit none
 
@@ -28,274 +19,25 @@
 !
 ! version: April 2012 - Franck Lefevre
+! update 06/03/2021 cpi/aki input (Yassin Jaziri)
 !=======================================================================
 
-!     declarations
- 
-#include "chimiedata.h"
 !     input/output
 
-      integer,intent(in) :: ngrid ! number of atmospheric columns
+      integer,intent(in) :: ngrid  ! number of atmospheric columns
       integer,intent(in) :: nlayer ! number of atmospheric layers
-      integer,intent(in) :: nq ! number of tracers
-      real,intent(in) :: pplay(ngrid,nlayer)
-      real,intent(in) :: pt(ngrid,nlayer)
-      real,intent(in) :: pdt(ngrid,nlayer)
-      real,intent(in) :: pq(ngrid,nlayer,nq)
-      real,intent(in) :: pdq(ngrid,nlayer,nq)
-      real,intent(in) :: ptimestep
+      integer,intent(in) :: nq     ! number of tracers
+      real,   intent(in) :: pplay(ngrid,nlayer)
+      real,   intent(in) :: pt(ngrid,nlayer)
+      real,   intent(in) :: pdt(ngrid,nlayer)
+      real,   intent(in) :: pq(ngrid,nlayer,nq)
+      real,   intent(in) :: pdq(ngrid,nlayer,nq)
+      real,   intent(in) :: ptimestep
 
 !     local variables
 
-      integer       :: i, l, ig, iq
-      integer, save :: nbq
-      integer,allocatable,save :: niq(:)
+      integer       :: l, ig, iq
       real          :: ni(nq), ntot
       real          :: zq(ngrid, nlayer, nq)
       real          :: zt(ngrid, nlayer)
-      real,allocatable,save    :: aki(:)
-      real,allocatable,save    :: cpi(:)
-
-      logical, save :: firstcall = .true.
-
-
-      if (firstcall) then
-
-         ! allocate local saved arrays:
-         allocate(aki(nq))
-         allocate(cpi(nq))
-         allocate(niq(nq))
-!        find index of chemical tracers to use
-!        initialize thermal conductivity and specific heat coefficients
-!        !? values are estimated
-
-         nbq = 0 ! to count number of tracers used in this subroutine
-
-         if (igcm_co2 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_co2
-            aki(nbq) = 3.072e-4
-            cpi(nbq) = 0.834e3
-         end if
-         if (igcm_co /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_co
-            aki(nbq) = 4.87e-4
-            cpi(nbq) = 1.034e3
-         end if
-         if (igcm_o /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_o
-            aki(nbq) = 7.59e-4
-            cpi(nbq) = 1.3e3
-         end if
-         if (igcm_o1d /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_o1d
-            aki(nbq) = 7.59e-4  !?
-            cpi(nbq) = 1.3e3    !?
-         end if
-         if (igcm_o2 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_o2
-            aki(nbq) = 5.68e-4
-            cpi(nbq) = 0.9194e3
-         end if
-         if (igcm_o3 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_o3
-            aki(nbq) = 3.00e-4  !?
-            cpi(nbq) = 0.800e3  !?
-         end if
-         if (igcm_h /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_h
-            aki(nbq) = 0.0
-            cpi(nbq) = 20.780e3
-         end if
-         if (igcm_h2 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_h2
-            aki(nbq) = 36.314e-4
-            cpi(nbq) = 14.266e3
-         end if
-         if (igcm_oh /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_oh
-            aki(nbq)  = 7.00e-4 !?
-            cpi(nbq)  = 1.045e3
-         end if
-         if (igcm_ho2 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_ho2
-            aki(nbq) = 0.0
-            cpi(nbq) = 1.065e3  !?
-         end if
-         if (igcm_h2o2 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_h2o2
-            aki(nbq) = 0.0
-            cpi(nbq) = 1.065e3  !?
-         end if
-         if (igcm_h2o_vap /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_h2o_vap
-            aki(nbq) = 0.0
-            cpi(nbq) = 1.870e3
-         end if
-         if (igcm_n /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_n
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_n2d /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_n2d
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_no /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_no
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_no2 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_no2
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if (igcm_n2 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_n2
-            aki(nbq) = 5.6e-4
-            cpi(nbq) = 1.034e3
-         end if
-         if(igcm_ch4 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_ch4
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_ch3 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_ch3
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_ch /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_ch
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_1ch2 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_1ch2
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_3ch2 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_3ch2
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_cho /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_cho
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_ch2o /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_ch2o
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_ch3o /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_ch3o
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_c /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_c
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_c2 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_c2
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_c2h /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_c2h
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_c2h2 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_c2h2
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_c2h3 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_c2h3
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_c2h4 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_c2h4
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_c2h6 /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_c2h6
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_ch2co /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_ch2co
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_ch3co /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_ch3co
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if(igcm_hcaer /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_hcaer
-            aki(nbq) = 0.0
-            cpi(nbq) = 0.0
-         endif
-         if (igcm_ar /= 0) then
-            nbq = nbq + 1
-            niq(nbq) = igcm_ar
-            aki(nbq) = 0.0      !?
-            cpi(nbq) = 1.000e3  !?
-         end if
-
-
-         ! tell the world about it:
-         write(*,*) "concentrations: firstcall, nbq=",nbq
-         write(*,*) "  niq(1:nbq)=",niq(1:nbq)
-         write(*,*) "  aki(1:nbq)=",aki(1:nbq)
-         write(*,*) "  cpi(1:nbq)=",cpi(1:nbq)
-
-         firstcall = .false.
-
-      end if ! if (firstcall)
 
 !     update temperature
@@ -311,6 +53,5 @@
       do l = 1,nlayer
          do ig = 1,ngrid
-            do i = 1,nbq
-               iq = niq(i) 
+            do iq = 1,nq
                zq(ig,l,iq) = max(1.e-30, pq(ig,l,iq)
      $                                 + pdq(ig,l,iq)*ptimestep)
@@ -325,7 +66,8 @@
       do l = 1,nlayer
          do ig = 1,ngrid
-            do i = 1,nbq
-               iq = niq(i)
-               mmean(ig,l) = mmean(ig,l) + zq(ig,l,iq)/mmol(iq)
+            do iq = 1,nq
+               if (mmol(iq).ne.0.) then
+                  mmean(ig,l) = mmean(ig,l) + zq(ig,l,iq)/mmol(iq)
+               end if
             end do
             mmean(ig,l) = 1./mmean(ig,l)
@@ -343,11 +85,10 @@
          do ig = 1,ngrid
             ntot = pplay(ig,l)/(1.381e-23*zt(ig,l))*1.e-6  ! in #/cm3
-            do i = 1,nbq
-               iq = niq(i) 
+            do iq = 1,nq
                ni(iq) = ntot*zq(ig,l,iq)*mmean(ig,l)/mmol(iq)
-               cpnew(ig,l) = cpnew(ig,l) + ni(iq)*cpi(i)
-               akknew(ig,l) = akknew(ig,l) + ni(iq)*aki(i)
+               cpnew(ig,l)  = cpnew(ig,l) + ni(iq)*cpi(iq)
+               akknew(ig,l) = akknew(ig,l) + ni(iq)*aki(iq)
             end do 
-            cpnew(ig,l) = cpnew(ig,l)/ntot
+            cpnew(ig,l)  = cpnew(ig,l)/ntot
             akknew(ig,l) = akknew(ig,l)/ntot
          end do
Index: trunk/LMDZ.GENERIC/libf/aeronostd/deposition_source.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/aeronostd/deposition_source.F90	(revision 2542)
+++ trunk/LMDZ.GENERIC/libf/aeronostd/deposition_source.F90	(revision 2542)
@@ -0,0 +1,79 @@
+      subroutine deposition_source(ngrid, nlayer, nq,   &
+                           ig, zzlay, zzlev,zdens,      &
+                           zycol, ptimestep)
+!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+!
+!     dry deposition of chemical species
+!
+!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+!
+      use chimiedata_h
+      use gases_h
+      use tracer_h, only: noms, nesp, mmol
+      use conc_mod, only: mmean ! mean molecular mass of the atmosphere
+
+      implicit none
+!
+!
+!     input
+! 
+      integer,intent(in) :: ngrid    ! number of atmospheric columns
+      integer,intent(in) :: nlayer   ! number of atmospheric layers
+      integer,intent(in) :: nq       ! number of tracers
+      integer ig                     ! grid point index
+      real    zzlay(ngrid,nlayer)    ! altitude at the middle of the layers (m)
+      real    zzlev(ngrid,nlayer+1)  ! altitude at layer boundaries (m)
+      real    zdens(nlayer)          ! density (cm^-3)
+      real    zycol(nlayer,nesp)     ! composition (volume mixing ratio)
+      real    ptimestep              ! physical timestep (s)
+!
+!     local
+!
+      real    vd                         ! dry deposition velocity (cm.s-1)
+      real    deltaz                     ! thickness of first layer (m)
+      real    deltaznlay                 ! thickness of last layer (m)
+      real    loss                       ! loss rate (s-1)
+      real    prod                       ! production rate (s-1) 
+      integer iq
+      logical, save :: firstcall = .true.
+
+
+      if (firstcall) then
+         print*,'photochemistry: initialize deposition/source'
+
+         ! You can set SF_mode/SF_value/prod_rate in traceur.def with #Moderntrac-v1
+         !! Cases SF_mode=1 (fixed mixing ratio)
+         !SF_mode(igcm_co2)=1
+         !SF_value(igcm_co2)=gfrac(igas_CO2)
+
+         !! Cases SF_mode=2 (production flux in molecules/m2/s)
+         !prod_rate(indexchim('co'))=3.0e13
+
+         firstcall=.false.
+      endif !firstcall
+
+      ! thickness of first layer (m)
+      deltaz = zzlev(ig,2) - zzlev(ig,1)
+      deltaznlay = zzlev(ig,nlayer) - zzlev(ig,nlayer-1)
+
+      ! hydrogen escape
+      !escape(ig,indexchim('h2'))=2.5e17*(zycol(nlayer,indexchim('h2'))+2*zycol(nlayer,indexchim('ch4'))+zycol(nlayer,indexchim('h2o_vap')))
+
+      do iq=1,nesp
+        if(SF_mode(iq).eq.1) then
+          surface_flux(ig,iq)=(SF_value(iq)-zycol(1,iq))/ptimestep*(zdens(1)*1e6*deltaz)
+          zycol(1,iq) = SF_value(iq)
+          !! Set mmr instead of vmr
+          !surface_flux(ig,iq)=(SF_value(iq)*mmean(ig,1)/mmol(iq+1)-zycol(1,iq))/ptimestep*(zdens(1)*1e6*deltaz)
+          !zycol(1,iq) = SF_value(iq)*mmean(ig,1)/mmol(iq+1)
+          zycol(nlayer,iq) = zycol(nlayer,iq)-ptimestep*escape(ig,iq)/(zdens(nlayer)*1e6*deltaznlay)
+        elseif(SF_mode(iq).eq.2) then ! loss/prod rate (s-1)
+          loss = 0.01*SF_value(iq)/deltaz
+          zycol(1,iq) = zycol(1,iq)*exp(-loss*ptimestep)+(prod_rate(iq)/(zdens(1)*1e6*deltaz))*ptimestep
+          zycol(nlayer,iq) = zycol(nlayer,iq)-ptimestep*escape(ig,iq)/(zdens(nlayer)*1e6*deltaznlay)
+          surface_flux(ig,iq)=-0.01*SF_value(iq)*zycol(1,iq)*(zdens(1)*1e6)+prod_rate(iq)
+        endif
+      enddo ! end nesp
+
+      return
+      end
Index: trunk/LMDZ.GENERIC/libf/aeronostd/pfunc.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/aeronostd/pfunc.F90	(revision 2542)
+++ trunk/LMDZ.GENERIC/libf/aeronostd/pfunc.F90	(revision 2542)
@@ -0,0 +1,95 @@
+module pfunc
+implicit none
+
+contains
+
+!=======================================================================
+! Reaction rate function
+!
+! version: April 2019 - Yassin Jaziri
+!=======================================================================
+
+
+function pfunc1(nlayer,t,dens,param)
+
+use types_asis
+
+implicit none
+
+! input/output
+
+integer                 :: nlayer       ! number of atmospheric layers
+real, dimension(nlayer) :: pfunc1       ! output values
+type(rtype1)            :: param        ! parameters
+real, dimension(nlayer) :: t            ! temperature (K)
+real, dimension(nlayer) :: dens         ! total number density (molecule.cm-3)
+
+
+pfunc1(:) = param%a*exp(-param%b/t(:))*((t(:)/param%t0)**param%c)*(dens(:)**param%d)
+
+return
+end function pfunc1
+
+
+function pfunc2(nlayer,t,dens,param)
+
+use types_asis
+
+implicit none
+
+! input/output
+
+integer                 :: nlayer       ! number of atmospheric layers
+real, dimension(nlayer) :: pfunc2       ! output values
+type(rtype2)            :: param        ! parameters
+real, dimension(nlayer) :: t            ! temperature (K)
+real, dimension(nlayer) :: dens         ! total number density (molecule.cm-3)
+
+! local
+
+real, dimension(nlayer) :: ak0, ak1, ak2, rate, xpo
+
+ak0(:)  = param%k0*exp(-param%a/t(:))*((t(:)/param%t0)**param%n)
+ak1(:)  = param%kinf*exp(-param%b/t(:))*((t(:)/param%t0)**param%m)
+ak2(:)  = param%g*exp(-param%h/t(:))
+rate(:) = (ak0(:)*dens(:)**param%dup)/(1. + ak0(:)*(dens(:)**param%ddown)/ak1(:))
+xpo(:)  = 1./(1. + alog10((ak0(:)*dens(:))/ak1(:))**2)
+
+pfunc2(:) = ak2(:) + rate(:)*(param%fc**xpo(:))
+
+return
+end function pfunc2
+
+function pfunc3(nlayer,t,dens,param)
+
+use types_asis
+
+implicit none
+
+! input/output
+
+integer                 :: nlayer       ! number of atmospheric layers
+real, dimension(nlayer) :: pfunc3       ! output values
+type(rtype3)            :: param        ! parameters
+real, dimension(nlayer) :: t            ! temperature (K)
+real, dimension(nlayer) :: dens         ! total number density (molecule.cm-3)
+
+! local
+
+real, dimension(nlayer) :: ak0, ak1, rate, fc, c, N, d, xpo
+
+ak0(:)  = param%k0*exp(-param%a/t(:))*((t(:)/param%t0)**param%n)
+ak1(:)  = param%kinf*exp(-param%b/t(:))*((t(:)/param%t0)**param%m)
+rate(:) = (ak0(:)*dens(:)**param%dup)/(1. + ak0(:)*(dens(:)**param%ddown)/ak1(:))
+fc(:)   = (1-param%atroe)*exp(-t(:)/param%btroe) + param%atroe*exp(-t(:)/param%ctroe) + exp(-param%dtroe/t(:))
+c(:)    = -0.4-0.67*alog10(fc(:))
+N(:)    = 0.75-1.27*alog10(fc(:))
+d(:)    = 0.14
+xpo(:)  = 1./(1. + ( (alog10((ak0(:)*dens(:))/ak1(:))+c(:))/(N(:)-d(:)*(alog10((ak0(:)*dens(:))/ak1(:))+c(:))) )**2)
+
+pfunc3(:) = rate(:)*(fc(:)**xpo(:))
+
+return
+end function pfunc3
+
+end module pfunc
